//****************************************************************************
//	
//	Copyright 2017 by WinSystems Inc.
//
//****************************************************************************
//
//	Name	 : lvdsControllerDLL.h
//
//	Project	 : LVDS Controller Windows DLL
//
//	Author	 : Paul DeMetrotion
//
//****************************************************************************
//
//	  Date		  Rev	                Description
//	--------    -------	   ---------------------------------------------
//	08/07/17	  1.0		Original Release of DLL	
//
//****************************************************************************

#ifndef _LVDS_CONTROLLER_DLL_H_
  #define _LVDS_CONTROLLER_DLL_H_

#if defined DLL_EXPORT
#define DECLDIR __declspec(dllexport)
#else
#define DECLDIR __declspec(dllimport)
#endif

extern "C"
{
    DECLDIR int InitializeSession();
    DECLDIR int blOnOff(unsigned int blControl);
    DECLDIR int blSetFrequency(unsigned int blFrequency);
    DECLDIR int blSetDutyCycle(unsigned int blDutyCycle);
    DECLDIR int CloseSession();
}

typedef enum {
    SUCCESS = 0,
    DRIVER_ERROR,
    INVALID_HANDLE,
    INVALID_PARAMETER
} ErrorCodes;

typedef enum {
    BL_ON = 0,
    BL_OFF
} blControl;

typedef enum {
    BL_FREQ_500 = 0,  // 500Hz
    BL_FREQ_400,      // 400 Hz
    BL_FREQ_300,      // 300 Hz
    BL_FREQ_275,      // 275 Hz
    BL_FREQ_250,      // 250 Hz
    BL_FREQ_225,      // 225 Hz
    BL_FREQ_200,      // 200 Hz
    BL_FREQ_100,      // 100 Hz
    MAX_BL_FREQ_OPTIONS
} blFrequency;

typedef enum {
    BL_DUTY_100 = 0,  // 100 %
    BL_DUTY_87_5,     // 87.5%
    BL_DUTY_75,       // 75%
    BL_DUTY_62_5,     // 62.5%
    BL_DUTY_50,       // 50%
    BL_DUTY_37_5,     // 37.5%
    BL_DUTY_25,       // 25%
    BL_DUTY_12_5,     // 12.5%
    BL_DUTY_0,        // 0%
    MAX_BL_DUTY_OPTIONS
} blDutyCycle;

#endif